aboutsummaryrefslogtreecommitdiff
path: root/tests/parallel.sh
diff options
context:
space:
mode:
Diffstat (limited to 'tests/parallel.sh')
-rw-r--r--tests/parallel.sh11
1 files changed, 10 insertions, 1 deletions
diff --git a/tests/parallel.sh b/tests/parallel.sh
index 798c15f5b..ddfb1523b 100644
--- a/tests/parallel.sh
+++ b/tests/parallel.sh
@@ -1,5 +1,6 @@
source common.sh
+
# First, test that -jN performs builds in parallel.
echo "testing nix-build -j..."
@@ -17,6 +18,7 @@ if test "$text" != "abacade"; then exit 1; fi
if test "$(cat $SHARED.cur)" != 0; then fail "wrong current process count"; fi
if test "$(cat $SHARED.max)" != 3; then fail "not enough parallelism"; fi
+
# Second, test that parallel invocations of nix-build perform builds
# in parallel, and don't block waiting on locks held by the others.
echo "testing multiple nix-build -j1..."
@@ -25,7 +27,9 @@ clearStore
rm -f $SHARED.cur $SHARED.max
-cmd="$nixbuild -j1 parallel.nix --argstr sleepTime 7"
+drvPath=$($nixinstantiate parallel.nix --argstr sleepTime 7)
+
+cmd="$nixstore -j1 -r $drvPath"
$cmd &
pid1=$!
@@ -39,9 +43,14 @@ $cmd &
pid3=$!
echo "pid 3 is $pid3"
+$cmd &
+pid4=$!
+echo "pid 4 is $pid4"
+
wait $pid1 || fail "instance 1 failed: $?"
wait $pid2 || fail "instance 2 failed: $?"
wait $pid3 || fail "instance 3 failed: $?"
+wait $pid4 || fail "instance 4 failed: $?"
if test "$(cat $SHARED.cur)" != 0; then fail "wrong current process count"; fi
if test "$(cat $SHARED.max)" != 3; then fail "not enough parallelism"; fi